// NumLockDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NumLockDlg.h"
#include "NumLockDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <afxpriv.h>              // For WM_KICKIDLE

/////////////////////////////////////////////////////////////////////////////
// CNumLockDlgDlg dialog

CNumLockDlgDlg::CNumLockDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNumLockDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNumLockDlgDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNumLockDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNumLockDlgDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNumLockDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CNumLockDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
  ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNumLockDlgDlg message handlers

BOOL CNumLockDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNumLockDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNumLockDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CNumLockDlgDlg::PreTranslateMessage(MSG* pMsg) 
{
  if( m_NumLock.FilterMessage( pMsg ))
    return TRUE;
  else
  	return CDialog::PreTranslateMessage(pMsg);
}
//////////////////
// Handle MFC private message WM_KICKIDLE. LPARAM is the idle count. 
// Return TRUE/FALSE continue/discontinue idle processing.//
LRESULT CNumLockDlgDlg::OnKickIdle(WPARAM, LPARAM lCount)
  {
  m_NumLock.CheckNumLockState();
  return 0;
  }

